"""
  Zamysel: analiz ELF-fajlow - podprogrammy.
  Ispolxz.: iz etudes/elf/doc/ - sp13.pdf i elf_form.pdf .
  Obnar.: w sekcii .dynsym net ssylok na imena ispolxzuemyh
dinam. b-k, hotq w .dynstr \ti imena estx, i readelf
ih obnruviwaet. Gde hranitsq inf. ob ispolxz. dinam.
b-kah - poka `to (na 2022,9,7) neqsno!
"""
from obscie import *
import os,sys

def set_whodn(imq0_):
 """
 imq0 - imq whodn. fajla.
 """
 global imq0,l_fajla
 # print 'set_whodn: imq0 = %s' % (repr(imq0_),)
 imq0 = imq0_
 l_fajla = set_whodn_(imq0_)

# --------

tabl_VA_A=[]  # Zanosim (name,VA0,Siz,A0).

def ww_header():
 global \
   e_ident,e_type,e_machine,e_version, \
   e_entry,e_phoff,e_shoff,e_flags, \
   e_ehsize, \
   e_phentsize,e_phnum,e_shentsize,e_shnum, \
   e_shstrndx
 print '----- ww_header -----\\'
 zago=ww_ofs(0,0x34,'zagolowok',otlad=True)
 f1=open('zagolo.dat','wb'); f1.write(zago); f1.close()

 fmt_zago="16sHHLLLLLHHHHHH" # l=struct.calcsize(fmt_zago) -> 52=0x34
 h=unpack(fmt_zago,zago)
 (e_ident,e_type,e_machine,e_version,
  e_entry,e_phoff,e_shoff,e_flags,
  e_ehsize,
  e_phentsize,e_phnum,e_shentsize,e_shnum,
  e_shstrndx
 )=h
 if e_ident[:4]!='\x7fELF': print 'Ne ELF !!!'; sys.exit(1)
 if e_ehsize!=0x34: print 'Razmer zagolowka =',e_ehsize,'!=0x34 !!!'; sys.exit(1)
 if e_phoff!=0 and e_phentsize!=0x20: print 'e_phentsize=',e_phentsize,'!!!'; sys.exit(1)
 if e_shoff!=0 and e_shentsize!=0x28: print 'e_shentsize=',e_shentsize,'!!!'; sys.exit(1)

 print 'e_type=',e_type # 0 - No type, 1 - *.o, 2 - exe, 3 - *.so, 4 - core. 
 print 'e_machine,=',e_machine  # 3 = Intel 80386.
 print 'e_version=',e_version
 # assert e_version==1
 print 'e_entry= 0x%08X' % (e_entry,)
 print 'e_shstrndx=',e_shstrndx  # =14 => imena sekcij nah. w 14-j sekcii.

 print 'PHT: e_phoff,e_phnum,e_phentsize=0x%08X %d %d' % (e_phoff,e_phnum,e_phentsize)
 print 'SHT: e_shoff,e_shnum,e_shentsize=0x%08X %d %d' % (e_shoff,e_shnum,e_shentsize)

 ari_PHT=e_phoff!=0
 ari_SHT=e_shoff!=0
 print '----- ww_header -----/'
 print ''
 return(ari_PHT,ari_SHT)

# --------

def anal_SHT():
 global s_names
 global sh_offset,sh_size
 print '----- anal_SHT -----\\'
 razmer=e_shentsize*e_shnum
 print 'SHT: 0x%08X..0x%08X; dlina = 0x%02X = %d = %d * %d' % (
   e_shoff,e_shoff+razmer,
   razmer,razmer,e_shentsize,e_shnum)
 print 'shstrndx:',e_shstrndx
 s_SHT=ww_ofs(e_shoff,e_shentsize*e_shnum,'SHT',otlad=True)
 f1=open('SHT.dat','wb'); f1.write(s_SHT); f1.close()

 anal_SHT_elt(e_shoff,e_shstrndx,names=None)

 names = ww_ofs(sh_offset,sh_size,'names', otlad=True)
 # f1=open('names.dat','wb'); f1.write(names); f1.close()
 # s_names=read_sect_names()
 # print repr(s_names)

 anal_SHT_elt_zagolo()
 for i in range(e_shnum):
  sh_offset,sh_size,sh_entsize,imq = anal_SHT_elt(e_shoff,i,names=names)

 """
 opis_sekcii_names,names = read_sect(e_shoff,e_shstrndx, treb_izwl=True)
 # names = imena sekcij w wide '\x00.symtab\x00.strtab\x00 ...'.
 names_=names.split('\x00')  # Dlq oprosa wida "if ... in names_".
 # print names_
 """
 print '----- anal_SHT -----/'

SHT_tipy = {
 0:'NULL',  1:'PROGBITS',  2:'SYMTAB',  3:'STRTAB',
 4:'RELA',  5:'HASH',  6:'DYNAMIC',  7:'NOTE',
 8:'NOBITS',  9:'REL',  10:'SHLIB',  11:'DYNSYM',
}

def anal_SHT_elt_zagolo():
 print '  ind  VA0        adr0  .. adr1       len entsize imq'

dynsym,dynstr,symtab,strtab,dynamic = None,None,None,None,None

def anal_SHT_elt(e_shoff,inde,names=None):
 """
 names - stroka im@n sekcij (sama qwlqetsq sekciej s inde=e_shstrndx).
 Dlq *.o, kogda fajl ne zagruva;t, sh_addr==0 .
 A sh_offset i sh_size - \to sme], i razmer w fajle.
 """
 global sh_offset,sh_size
 global dynsym,dynstr,symtab,strtab,dynamic

 # print '----- anal_sht_elt '+str(inde)+' -----\\'
 adr=e_shoff+0x28*inde
 s=ww_ofs(adr,0x28,'sht_elt',otlad=False)
 fmt_sht_elt="LLLLLLLLLL"   
 h = unpack(fmt_sht_elt,s)
 (sh_name,sh_type,sh_flags,sh_addr,sh_offset,sh_size,sh_link,sh_info,
  sh_addralign,sh_entsize
 )=h
 if sh_type in SHT_tipy: s_tip=SHT_tipy[sh_type]
 else: s_tip='???'
 # print '%08X + %08X = %08X offs size' % (sh_offset,sh_size,sh_offset+sh_size)

 if names==None:  # Pri perwom zapuske dlq nahovdeniq 'names'.
  # print '----- anal_sht_elt '+str(inde)+' -----/'
  return

 imq=''
 if names!='': 
  ofs=sh_name
  while names[ofs]!=chr(0): imq=imq+names[ofs]; ofs=ofs+1
 sx=ww_ofs(sh_offset,sh_size,'sekciq_'+str(inde)+'.dat',otlad=False)
 print '%4d %08X / %08X..%08X %6d %4d %-16s %s' % (
  inde,sh_addr,sh_offset,sh_offset+sh_size,sh_size,sh_entsize,imq,printable_s(sx[:40]))

 tabl_VA_A.append((imq,sh_addr,sh_size,sh_offset))

 if imq=='.dynsym': dynsym=len(tabl_VA_A)-1
 if imq=='.dynstr': dynstr=len(tabl_VA_A)-1
 if imq=='.symtab': symtab=len(tabl_VA_A)-1
 if imq=='.strtab': strtab=len(tabl_VA_A)-1
 if imq=='.dynamic': dynamic=len(tabl_VA_A)-1

 if imq and sh_size:
  f1=open(str(inde)+'_'+imq+'.dat','wb'); f1.write(sx); f1.close()

 # print '----- anal_sht_elt '+str(inde)+' -----/'
 return(sh_offset,sh_size,sh_entsize,imq)

# --------

def anal_PHT():
 print '----- anal_PHT -----\\'
 razmer=e_phentsize*e_phnum
 print 'PHT: 0x%08X..0x%08X; dlina = 0x%02X = %d = %d * %d' % (
   e_phoff,e_phoff+razmer,
   razmer,razmer,e_phentsize,e_phnum)
 s_PHT=ww_ofs(e_phoff,e_phentsize*e_phnum,'PHT',otlad=True)
 f1=open('PHT.dat','wb'); f1.write(s_PHT); f1.close()

 anal_PHT_elt_zagolo()
 for i in range(e_phnum):
  anal_PHT_elt(e_phoff,i)
 print ''
 print '----- anal_PHT -----/'

def read_PHT_entry(e_phoff,i):
 adr=e_phoff+0x20*i
 s=ww_ofs(adr,0x20,'PHT entry',otlad=False)

 fmt_PHT_elt="LLLLLLLL"   
 opis_entry=unpack(fmt_PHT_elt,s)
 return(opis_entry)

def anal_PHT_elt_zagolo():
 print '   i type     fileofs  filesiz  sum      VA       memsiz   flags    align' 

def anal_PHT_elt(e_phoff,i):
 opis_entry = read_PHT_entry(e_phoff,i)
 (type,fileofs,VA,PA_unused,filesiz,memsiz,flags,align
 )=opis_entry
 print '%4d %08X %08X %08X %08X %08X %08X %08X %08X' % (
   i,type,fileofs,filesiz,fileofs+filesiz,VA,memsiz,flags,align)

# --------

def anal_symb_table(symtab_,strtab_):
 "Predp. entsize=16."
 # print '----- anal_symb_table -----\\'

 imq,sh_addr,sh_size,sh_offset = tabl_VA_A[symtab_]
 symtab,errcode = read_xxx(sh_offset,sh_size, comment=imq, otlad=False)
 imq_str,sh_addr,sh_size,sh_offset = tabl_VA_A[strtab_]
 strtab,errcode = read_xxx(sh_offset,sh_size, comment=imq_str, otlad=False)

 # print 'len(symtab)=',len(symtab)
 # print 'len(strtab)=',len(strtab)

 n = len(symtab)/16
 # print 'n=',n

 # print '-'*32
 print '          value'
 print ' adres    (adres    dlina  bind type ind'
 print ' imeni    koda)'

 for i in range(n):
  s = symtab[16*i:16*(i+1)]
  adr_name,val,dlina,n12,dupa,ind = unpack('LLLBBh',s)
  # print '%02X %02X %04X' % (n12,dupa,ind)
  bind = n12/16; type = n12%16
  imq = ww_str_end0_(strtab,adr_name)

  s1 = '  %02X' % (bind,)
  if bind==0: s1='loca'
  if bind==1: s1='glob'
  if bind==2: s1='weak'

  s2 = '  %02X' % (type,)
  if type==1: s2='obje'
  if type==2: s2='func'
  if type==3: s2='sect'
  if type==4: s2='file'

  s3 = '%d' % (ind,)   
  # ind == nomer sekcii, k k-roj prinadl. ob'ekt;
  # movno bylo by wmesto nomera wydawatx e@ imq.
  if ind==0: s3='UND*'
  if ind==-0xF: s3='ABS*'

  print '%08X %08X %08X %-4s %-4s %-4s %s' % \
    (adr_name,val,dlina,s1,s2,s3,repr(imq)) 

 # print '----- anal_symb_table -----/'

def anal_symtab():
 print '----- anal_symtab -----\\'
 if symtab==None or strtab==None:
  print 'symtab,strtab=',symtab,strtab
  print '----- anal_symtab -----/'
  return
 anal_symb_table(symtab,strtab)
 print '----- anal_symtab -----/'

def anal_dynsym():
 print '----- anal_dynsym -----\\'
 if dynsym==None or dynstr==None:
  print 'dynsym,dynstr=',dynsym,dynstr
  print '----- anal_dynsym -----/'
  return
 anal_symb_table(dynsym,dynstr)
 print '----- anal_dynsym -----/'

# --------

def anal_dynamic():
 if dynamic==None:
  print 'anal_dynamic: dynamic=',dynamic
  return
 """
 print symtab
 print strtab
 print dynsym
 print dynstr
 print dynamic
 """
 print '----- anal_dynamic -----\\'
 imq,sh_addr,sh_size,sh_offset = tabl_VA_A[dynamic]
 dy,errcode = read_xxx(sh_offset,sh_size, comment=imq, otlad=False)
 imq_str,sh_addr,sh_size,sh_offset = tabl_VA_A[dynstr]
 sy,errcode = read_xxx(sh_offset,sh_size, comment=imq_str, otlad=False)
 n = len(dy)/8
 for i in range(n):
  s=dy[8*i:8*(i+1)]
  val,ptr = unpack('LL',s)
  if val==1:
   imq_needed = ww_str_end0_(sy,ptr)
   print 'NEEDED',imq_needed
 print '----- anal_dynamic -----/'

def VA_A(VA, otlad=True):
 if otlad: print 'VA_A: VA=%08X' % (VA)
 name,A = None,None
 for i in range(len(tabl_VA_A)):
  (imq,VA0,Siz,A0)=tabl_VA_A[i]
  if otlad: print '%08X / %-12s / %08X %08X..%08X / %08X..%08X' % \
    (VA,imq[:12],Siz, VA0,VA0+Siz, A0,A0+Siz)
  if VA>=VA0 and VA<VA0+Siz: A=VA-VA0+A0; name=imq; break
 if A==None:
  print 'VA_A - err.: VA=%08X !!!' % (VA)
  i=0; i=1/i
 else:
  if otlad: print 'VA_A: VA,name,A = (%08X, %s, %08X)' % (VA,name,A)
 return(A)   

def anal_entry():
 print '----- anal_entry -----\\'
 A = VA_A(e_entry, otlad=False)
 if A!=None: print 'e_entry,A= %08X %08X' % (e_entry,A)
 else:       print 'e_entry,A= %08X %s' % (e_entry,A)
 print '----- anal_entry -----/'

# --------

if __name__=='__main__':
 ss=dir()
 for s in ss: print s
